// AIRDemoView.cpp : implementation of the CAIRDemoView class
//

#include "stdafx.h"
#include "AIRDemo.h"

#include "AIRDemoDoc.h"
#include "AIRDemoView.h"

#include <GL/glu.h>
#include <GL/gl.h>
#include <deque>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAIRDemoView

IMPLEMENT_DYNCREATE(CAIRDemoView, CView)

BEGIN_MESSAGE_MAP(CAIRDemoView, CView)
	//{{AFX_MSG_MAP(CAIRDemoView)
	ON_WM_CREATE()
	ON_WM_SIZE()
	ON_WM_DESTROY()
	ON_WM_TIMER()
	ON_WM_ERASEBKGND()
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAIRDemoView construction/destruction


unsigned char threeto8[8] = {
    0, 0111>>1, 0222>>1, 0333>>1, 0444>>1, 0555>>1, 0666>>1, 0377
};

unsigned char twoto8[4] = {
    0, 0x55, 0xaa, 0xff
};

unsigned char oneto8[2] = {
    0, 255
};

static int defaultOverride[13] = {
    0, 3, 24, 27, 64, 67, 88, 173, 181, 236, 247, 164, 91
};

static PALETTEENTRY defaultPalEntry[20] = {
    { 0,   0,   0,    0 },
    { 0x80,0,   0,    0 },
    { 0,   0x80,0,    0 },
    { 0x80,0x80,0,    0 },
    { 0,   0,   0x80, 0 },
    { 0x80,0,   0x80, 0 },
    { 0,   0x80,0x80, 0 },
    { 0xC0,0xC0,0xC0, 0 },

    { 192, 220, 192,  0 },
    { 166, 202, 240,  0 },
    { 255, 251, 240,  0 },
    { 160, 160, 164,  0 },

    { 0x80,0x80,0x80, 0 },
    { 0xFF,0,   0,    0 },
    { 0,   0xFF,0,    0 },
    { 0xFF,0xFF,0,    0 },
    { 0,   0,   0xFF, 0 },
    { 0xFF,0,   0xFF, 0 },
    { 0,   0xFF,0xFF, 0 },
    { 0xFF,0xFF,0xFF, 0 }
};


CAIRDemoView::CAIRDemoView()
{
	// TODO: add construction code here
}

CAIRDemoView::~CAIRDemoView()
{

}

BOOL CAIRDemoView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

    // An OpenGL window must be created with the following flags and must not
    // include CS_PARENTDC for the class style. Refer to SetPixelFormat
    // documentation in the "Comments" section for further information.
    cs.style |= WS_CLIPSIBLINGS | WS_CLIPCHILDREN;

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CAIRDemoView drawing

void CAIRDemoView::OnDraw(CDC* pDC)
{
	CAIRDemoDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: add draw code for native data here
	
	DrawScene() ;
}

/////////////////////////////////////////////////////////////////////////////
// CAIRDemoView printing

BOOL CAIRDemoView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CAIRDemoView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CAIRDemoView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CAIRDemoView diagnostics

#ifdef _DEBUG
void CAIRDemoView::AssertValid() const
{
	CView::AssertValid();
}

void CAIRDemoView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CAIRDemoDoc* CAIRDemoView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CAIRDemoDoc)));
	return (CAIRDemoDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CAIRDemoView message handlers

int CAIRDemoView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: Add your specialized creation code here
	Init() ;

	return 0;
}

void CAIRDemoView::OnSize(UINT nType, int cx, int cy) 
{
	CView::OnSize(nType, cx, cy);
	
	// TODO: Add your message handler code here
    if (cy > 0)
    {    
        glViewport(0, 0, cx, cy);

//        if ((m_oldRect.right > cx) || (m_oldRect.bottom > cy))
//          RedrawWindow();

        m_oldRect.right = cx;
        m_oldRect.bottom = cy;

        glMatrixMode(GL_PROJECTION);
        glLoadIdentity();
 		glOrtho(0, 0, cx, cy, -1, 1) ;
        glMatrixMode(GL_MODELVIEW);

    }		

}

void CAIRDemoView::OnDestroy() 
{
	CView::OnDestroy();
	
	// TODO: Add your message handler code here
	
    HGLRC   hrc;

    if (m_nTimerID)
        KillTimer(m_nTimerID);

	hrc	 = ::wglGetCurrentContext();

    ::wglMakeCurrent(NULL,  NULL);

    if (hrc)
        ::wglDeleteContext(hrc);

    CPalette    palDefault;

    // Select our palette out of the dc
    palDefault.CreateStockObject(DEFAULT_PALETTE);
    m_pDC->SelectPalette(&palDefault, FALSE);

    if (m_pDC)
        delete m_pDC;

}

void CAIRDemoView::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	
	DrawScene() ;
	CView::OnTimer(nIDEvent);
}

void CAIRDemoView::Init()
{
    PIXELFORMATDESCRIPTOR pfd;
    int         n;
	HGLRC		hrc;


    m_pDC = new CClientDC(this);

//	m_pDC->SelectStockObject(BLACK_BRUSH) ;
//	CBrush brush;
//	brush.CreateSolidBrush(RGB(0, 0, 0)) ;
//	m_pDC->SelectObject(brush) ;

    ASSERT(m_pDC != NULL);

    if (!bSetupPixelFormat())
        return;

    n = ::GetPixelFormat(m_pDC->GetSafeHdc());
    ::DescribePixelFormat(m_pDC->GetSafeHdc(), n, sizeof(pfd), &pfd);

    CreateRGBPalette();

    // create a rendering context and make it current
        
    hrc = wglCreateContext(m_pDC->GetSafeHdc());

    wglMakeCurrent(m_pDC->GetSafeHdc(), hrc);

	// font
	wglUseFontBitmaps (m_pDC->GetSafeHdc() , 0, 255, 1000); 
	glListBase (1000); 

    GetClientRect(&m_oldRect);
    glClearDepth(1.0f);
    glEnable(GL_DEPTH_TEST);



/*	GLfloat     fMaxObjSize, fAspect;
	GLfloat     fNearPlane, fFarPlane;
    fAspect = (GLfloat)m_oldRect.right / m_oldRect.bottom;
	fNearPlane = 3.0f;
	fFarPlane = 7.0f;
	fMaxObjSize = 3.0f;
	m_fRadius = fNearPlane + fMaxObjSize / 2.0f;

    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    gluPerspective(45.0f, fAspect, fNearPlane, fFarPlane);
    glMatrixMode(GL_MODELVIEW);
*/

//	m_nTimerID = SetTimer(1, 50, NULL);
//	ASSERT(m_nTimerID != NULL);
}

BOOL CAIRDemoView::bSetupPixelFormat()
{
    static PIXELFORMATDESCRIPTOR pfd =
    {
        sizeof(PIXELFORMATDESCRIPTOR),  // size of this pfd
        1,                              // version number
        PFD_DRAW_TO_WINDOW |            // support window
          PFD_SUPPORT_OPENGL |          // support OpenGL
          PFD_DOUBLEBUFFER,             // double buffered
        PFD_TYPE_RGBA,                  // RGBA type
        24,                             // 24-bit color depth
        0, 0, 0, 0, 0, 0,               // color bits ignored
        0,                              // no alpha buffer
        0,                              // shift bit ignored
        0,                              // no accumulation buffer
        0, 0, 0, 0,                     // accum bits ignored
        16,                             // 16-bit z-buffer
        0,                              // no stencil buffer
        0,                              // no auxiliary buffer
        PFD_MAIN_PLANE,                 // main layer
        0,                              // reserved
        0, 0, 0                         // layer masks ignored
    };

    int     pixelformat;

    if ( (pixelformat = ChoosePixelFormat(m_pDC->GetSafeHdc(), &pfd)) == 0 )
    {
        MessageBox("ChoosePixelFormat failed");
        return FALSE;
    }

    if (SetPixelFormat(m_pDC->GetSafeHdc(), pixelformat, &pfd) == FALSE)
    {
        MessageBox("SetPixelFormat failed");
        return FALSE;
    }

    return TRUE;
}

unsigned char CAIRDemoView::ComponentFromIndex(int i, UINT nbits, UINT shift)
{
    unsigned char val;

    val = (unsigned char) (i >> shift);

    switch (nbits)
    {
        case 1:
            val &= 0x1;
            return oneto8[val];

        case 2:
            val &= 0x3;
            return twoto8[val];

        case 3:
            val &= 0x7;
            return threeto8[val];

        default:
            return 0;
    }
}

void CAIRDemoView::CreateRGBPalette()
{
    PIXELFORMATDESCRIPTOR pfd;
    LOGPALETTE  *pPal;
    WORD        n, i;

    n = ::GetPixelFormat(m_pDC->GetSafeHdc());
    ::DescribePixelFormat(m_pDC->GetSafeHdc(), n, sizeof(pfd), &pfd);

    if (pfd.dwFlags & PFD_NEED_PALETTE)
    {
        n = 1 << pfd.cColorBits;

                                               
        pPal = (PLOGPALETTE) new BYTE[sizeof(LOGPALETTE) + n * sizeof(PALETTEENTRY)];

        ASSERT(pPal != NULL);

        pPal->palVersion = 0x300;
        pPal->palNumEntries = n;

        for (i=0; i<n; i++)
        {
            pPal->palPalEntry[i].peRed =
                    ComponentFromIndex(i, pfd.cRedBits, pfd.cRedShift);
            pPal->palPalEntry[i].peGreen =
                    ComponentFromIndex(i, pfd.cGreenBits, pfd.cGreenShift);
            pPal->palPalEntry[i].peBlue =
                    ComponentFromIndex(i, pfd.cBlueBits, pfd.cBlueShift);
            pPal->palPalEntry[i].peFlags = 0;
        }

        // fix up the palette to include the default GDI palette

        if ((pfd.cColorBits == 8)                           &&
            (pfd.cRedBits   == 3) && (pfd.cRedShift   == 0) &&
            (pfd.cGreenBits == 3) && (pfd.cGreenShift == 3) &&
            (pfd.cBlueBits  == 2) && (pfd.cBlueShift  == 6)
           )
        {
			for (i = 1 ; i <= 12 ; i++)
                pPal->palPalEntry[defaultOverride[i]] = defaultPalEntry[i];
        }
        

        m_cPalette.CreatePalette(pPal);
        delete pPal;

        m_pDC->SelectPalette(&m_cPalette, FALSE);
        m_pDC->RealizePalette();
    }
}

void CAIRDemoView::DrawScene(void)
{
    static BOOL     bBusy = FALSE;
	int i, j ;

	const float yellow[] = { 1.0, 1.0, 0.0, 1.0 } ;
	const float purple[] = { 1.0, 0.0, 1.0, 1.0 } ;
	const float color[][4] = { 
								{1.0f, 0.0f, 0.0f, 1.0f}, 
								{0.0f, 1.0f, 0.0f, 1.0f},
								{0.0f, 0.0f, 1.0f, 1.0f},
								{0.5f, 0.0f, 0.0f, 1.0f},
								{0.0f, 0.5f, 0.0f, 1.0f},
								{0.0f, 0.0f, 0.5f, 1.0f},
	} ;


	CAIRDemoDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	
    if(bBusy || !pDoc->bp->Loaded() )
        return;

	double top, bottom, left, right ;
	double height_interval ;
	char Str[128] ;

	_gcvt(pDoc->E, 32, Str) ;

    bBusy = TRUE;
	top = pDoc->DataBound.top ;
	bottom = pDoc->DataBound.bottom ;
	left = pDoc->DataBound.left ;
	right = pDoc->DataBound.right ;
	height_interval = (top - bottom) / 10 ;

    glClearColor(0.0f, 0.0f, 0.0f, 1.0f);
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	// Display Current Error

	glColor3f(1.0f, 1.0f, 1.0f) ;
	glRasterPos2d( left, bottom) ;
	glCallLists (strlen(Str) , GL_UNSIGNED_BYTE, Str); 

	sprintf(Str, "Current Input Layer is %d", pDoc->CurInputLayer ) ;
	glRasterPos2d( left, bottom+height_interval) ;
	glCallLists(strlen(Str), GL_UNSIGNED_BYTE, Str ) ;

	sprintf(Str, "Current Conflict Layer is %d", pDoc->CurConflictLayer ) ;
	glRasterPos2d( left, bottom+2*height_interval) ;
	glCallLists(strlen(Str), GL_UNSIGNED_BYTE, Str ) ;

	sprintf(Str, "Current Neuron is %d %d ", pDoc->CurXAxis, pDoc->CurYAxis ) ;
	glRasterPos2d( left, bottom+3*height_interval) ;
	glCallLists(strlen(Str), GL_UNSIGNED_BYTE, Str ) ;

	if( pDoc->display_mode == CAIRDemoDoc::Process ) {
		AIR_BP * bp = pDoc->bp ;

		double * pat ;
		double * desire ;
		double ** Weight ;

		int IndX, IndY, Layer; 
		int Upper_Layer_Num_Neuron, This_Layer_Num_Neuron ;


		IndX = pDoc->CurXAxis ;
		IndY = pDoc->CurYAxis ;
		Layer = pDoc->CurInputLayer ;

		Upper_Layer_Num_Neuron = bp->GetNumNeuron(Layer+1) ;
		This_Layer_Num_Neuron = bp->GetNumNeuron(Layer) ;

		Weight = bp->GetWeight(Layer) ;	

		ReProject( pDoc->DataBound ) ;
		
		// draw the patterns
		glPointSize(3.0) ;
		glBegin(GL_POINTS) ;

		for ( i = 0 ; i < bp->GetNumPat() ; i++ ){

			// simulate the result
			pat = bp->Sim2( pDoc->CurInputLayer, i) ;

			desire = bp->GetDesire(i) ;

			if( desire[0] > 0.0 ) 
				glColor3fv(yellow) ;
			else
				glColor3fv(purple) ;

			glVertex2d(pat[IndX], pat[IndY]) ;
		}
		glEnd() ;

		// draw the Hyper-Planes
		for( i = 0 ; i < Upper_Layer_Num_Neuron ; i++ ){
			double root ;
			double w1, w2, bias ;
			double pt[2][2] ;		// intersection of hyper-line & DataBound

			w1 = Weight[i][IndX] ;
			w2 = Weight[i][IndY] ;
			bias = Weight[i][This_Layer_Num_Neuron] ;

			glColor3fv(color[i]) ;

			// reset index; 
			j = 0 ;

			// left line
			root = - ( w1 * left + bias	) / w2 ;
			if( root >= bottom && root <= top ){
				pt[j][0] = left ;
				pt[j][1] = root ;
				j++ ;
			}

			// right line
			root = - ( w1 * right + bias) / w2 ;
			if( root >= bottom && root <= top ){
				pt[j][0] = right ;
				pt[j][1] = root ;
				j++ ;
			}

			// bot
			root = - ( w2 * bottom + bias ) / w1 ;
			if( root >= left && root <= right ){
				pt[j][0] = root ;
				pt[j][1] = bottom ;
				j++ ;
			}

			// top line
			root = - ( w2 * top + bias ) / w1 ;
			if( root >= left && root <= right ){
				pt[j][0] = root ;
				pt[j][1] = top ;
				j++ ;
			}

			// hyper-line && oriention
			if( j == 2 ) {
				// display the oriention

				double px, py ;
				px = ( pt[0][0] + pt[1][0] ) / 2.0 ;
				py = ( pt[0][1] + pt[1][1] ) / 2.0 ;
				
				glBegin(GL_POINTS) ;
				if( (px+1.0) * w1 + py * w2 + bias > 0 ) 
					glVertex2d(px+1.0, py) ;
				else
					glVertex2d(px-1.0, py) ;
				glEnd() ;

				// hyper-line
				glBegin(GL_LINES) ;
				glVertex2dv(pt[0]) ;
				glVertex2dv(pt[1]) ;
				glEnd() ;
			}
		}

	}

	else if( pDoc->display_mode == CAIRDemoDoc::Tree ) {
		double initX, initY, X, y, nx;
		double w_ival ;
		double h_ival ;

		double width = right - left ;
		double height = top - bottom ;

		std::deque<HammingTreeNode *> q ;
		std::deque<HammingTreeNode *>::iterator cmp_iter ;
		std::vector<HammingTreeNode *>::iterator iter ;
		HammingTreeNode * node ;

		if( !pDoc->bp->_proot )
			goto EXIT ;

		node = pDoc->bp->_proot ;

		nx = X = initX = left + 0.1 * width ;
		y = initY = top - 0.1 * height ;
		w_ival = width * 0.9 / node->sum_leaf ;
		h_ival = height * 0.9 / node->layer ;

		q.push_back(node) ;

		cmp_iter = q.end() ;

		while( !q.empty() ){

			node = q.front() ;

			if( cmp_iter == q.begin() ){
				cmp_iter = q.end() ;
				nx = X = initX ;
				y -= h_ival ;
			}

			if( node != pDoc->bp->_proot ){
				if( node->state == Pure ){
					glColor3f(1.0f, 1.0f, 1.0f) ;
//					sprintf(Str, "Pat: %X Des: %X", node->bitpat, node->desire);
					sprintf(Str, "Pat: %X", node->bitpat);
					glRasterPos2d(X, y) ;
					glCallLists(strlen(Str), GL_UNSIGNED_BYTE, Str) ;

				}

				else if( node->state == Conflict ){
					glColor3f(1.0f, 0.0f, 0.0f) ;
					sprintf(Str, "Pat: %X", node->bitpat);
					glRasterPos2d(X, y) ;
					glCallLists(strlen(Str), GL_UNSIGNED_BYTE, Str) ;
				}
			}

			glBegin(GL_POINTS);
			glVertex2d(X, y);
			glEnd();
		
			for( iter = node->_list_child.begin() ; iter != node->_list_child.end() ; iter++ ){		
			
				glBegin(GL_LINES);
				glVertex2d(X, y) ;
				glVertex2d(nx, y-h_ival) ;
				glEnd() ;

				nx += w_ival * (*iter)->sum_leaf;		// proceed position in child layer
				q.push_back(*iter) ;
			}
		
			X += w_ival * node->sum_leaf;		// increment the current layer position, because this parent is already done

			q.pop_front() ;		// next parent 

		}
	}
EXIT :
    SwapBuffers(wglGetCurrentDC());
    bBusy = FALSE;
}

void CAIRDemoView::ReProject(double left, double right, double bot, double top) {
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glOrtho(left, right, bot, top, -1.0, 1.0) ;
	glMatrixMode(GL_MODELVIEW);
}

void CAIRDemoView::ReProject(BPRect& DataBound){
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glOrtho(DataBound.left, DataBound.right, DataBound.bottom, DataBound.top, -1.0, 1.0) ;
	glMatrixMode(GL_MODELVIEW);	
}

BOOL CAIRDemoView::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	// TODO: Add your specialized code here and/or call the base class
	LPCTSTR lpszClass = 
		AfxRegisterWndClass( CS_HREDRAW | CS_VREDRAW | CS_OWNDC,
				//LoadCursorFromFile("res\\cursor1.cur"), 
				NULL,  // pointer
				NULL,  // brush
				NULL   ) ;	// icon 
	
	return CWnd::Create(lpszClass, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
}

BOOL CAIRDemoView::OnEraseBkgnd(CDC* pDC) 
{
	// TODO: Add your message handler code here and/or call default
	if( ! GetDocument()->m_UI_training ) {
		glClearColor(0.0f, 0.0f, 0.0f, 1.0f);
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
		SwapBuffers(wglGetCurrentDC());
	}

	return CView::OnEraseBkgnd(pDC);
}
