// AIRDemoView.h : interface of the CAIRDemoView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_AIRDEMOVIEW_H__CE0D19DC_8171_46F1_84A6_8ACFE5A975EF__INCLUDED_)
#define AFX_AIRDEMOVIEW_H__CE0D19DC_8171_46F1_84A6_8ACFE5A975EF__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#include "../BPSystem./AIR_BP.h"

class CAIRDemoView : public CView
{
protected: // create from serialization only
	CAIRDemoView();
	DECLARE_DYNCREATE(CAIRDemoView)

// Attributes
public:
	CAIRDemoDoc* GetDocument();
    CPalette    m_cPalette;
    CClientDC   *m_pDC;
	CRect		m_oldRect;
	float		m_fRadius;


private:
	UINT        m_nTimerID;

// Operations
public:
    void Init();
    void CreateRGBPalette();
    BOOL bSetupPixelFormat();
    unsigned char ComponentFromIndex(int i, UINT nbits, UINT shift);
    void DrawScene(void);
	
	void ReProject(double left, double right, double bot, double top) ;
	void ReProject(BPRect& DataBound) ;

	// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAIRDemoView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CAIRDemoView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	

// Generated message map functions
protected:
	//{{AFX_MSG(CAIRDemoView)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnDestroy();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in AIRDemoView.cpp
inline CAIRDemoDoc* CAIRDemoView::GetDocument()
   { return (CAIRDemoDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_AIRDEMOVIEW_H__CE0D19DC_8171_46F1_84A6_8ACFE5A975EF__INCLUDED_)
