#include "AIR_BP.h"
#include <queue>

AIR_BP::AIR_BP(){
	extend_step = 5 ;
	Training_Mask = 0 ;
	Remain_Empty = 0 ;
	m_Weight_Buf = 0 ;
	add_neuron_mode = Random ;
}
AIR_BP::~AIR_BP(){
	DestroyBP() ;
}

int AIR_BP::Load(const char* filename){
	if( !SuperviseSystem::Load(filename) ) 
		return 0;

	int i, j;
	// allocate memory ;
	Training_Mask = new int* [num_layer+1] ;
	for( i = 0 ; i < num_layer+1 ; i++ ){
		Training_Mask[i] = new int [neuron[i]] ;
		for( j = 0 ; j < neuron[i] ; j++ )
			Training_Mask[i][j] = 0 ;	// initially unmasked
	}

	// initial all empty
	Remain_Empty = new int [num_layer+1] ;
	for( i = 0 ; i < num_layer+1 ; i++ )
		Remain_Empty[i] = 0 ;

	return 1 ;
}

int AIR_BP::DestroyBP(){
	int i ;

	if( Remain_Empty ) {
		delete [] Remain_Empty ;
		Remain_Empty = 0 ;
	}

	if( Training_Mask ) {
		for( i = 0 ; i < num_layer+1 ; i++ )
			delete [] Training_Mask[i] ;
		delete [] Training_Mask ;
		Training_Mask = 0 ;
	}

	if( m_Weight_Buf ) 
		delete [] m_Weight_Buf ;

	return SuperviseSystem::DestroyBP() ;
}

/*
int AIR_BP::add_neuron(int n, int layer){

	int i, j;

	if( layer >= num_layer || layer <= 0 ) 
		return 0 ;

//	if( flag_weight_mask ) 
//		AmbiguityTest(1) ;

	// the parameter 1 means do not modify  the weight,
	// only report the current conflict layer
	if( add_neuron_mode == AIR ) 
		layer = AmbiguityTest(1) ;

	// there are many variables to extend its size
	// Hidden layer : X[layer]
	// Weight : Weight[layer-1], Weight[layer] 
	// Sumation node : S[layer]
	// Error propagation : Error[layer]
	
	// variables to modify its value
	// num of neuron : neuron[layer]
	// Remain_Empty : because it has to
	if( Remain_Empty[layer] > 0 ){ 

		X[layer][neuron[layer]+1] = 1.0 ; // threshold node shift

		// Weight modification is to be coded here	***************************************

		// for upper layer
		for( i = 0 ; i < neuron[layer+1] ; i++ ){
			Weight[layer][i][neuron[layer]+1] = Weight[layer][i][neuron[layer]] ; // shift the weight of threshold
			Weight[layer][i][neuron[layer]] = rand_weight(1.0) ;	// give a random weight to the new neuron
		}

		// for low layer
		if( add_neuron_mode == Random ) {
			for( j = 0 ; j < neuron[layer-1]+1 ; j++ )
				Weight[layer-1][neuron[layer]][j] = rand_weight(1.0) ;	// give a random weight
		}

		else if( add_neuron_mode == AIR ){
			int count ;
			double sum  ;

			for( i = 0  ; i < neuron[layer-1] + 1 ; i++ ){
				
				count = 0 ;
				sum = 0.0 ;

				for( j = 0 ; j < neuron[layer] ; j++ ){		// average of unmasked neuron
					if( Training_Mask[layer][j] == 0 ) {
						sum += Weight[layer-1][j][i] ; 
						count++ ;
					}
				}
				Weight[layer-1][neuron[layer]][i] = sum / count ;
			}
		}
			

		// initially unmasked
		Training_Mask[layer][neuron[layer]] = 0 ;

		neuron[layer]++ ;
		Remain_Empty[layer]-- ;
	}

	else{	// extend the layer specified
		int neuron_this_layer = neuron[layer] ;

		double * pX ;

		// extension for X[layer]
		pX = new double [neuron_this_layer + 1 + extend_step ] ;
		pX[neuron_this_layer+1] = 1.0;	// set bias to 1.0

		for( i = 0 ; i < neuron_this_layer ; i++ )
			pX[i] = X[layer][i] ;
		pX[i] =  1.0 ;
		pX[i+1] = 1.0 ;

		delete [] X[layer] ;
		X[layer] = pX ;
		
		double * pS ;

		// extension for S[layer]
		pS = new double [neuron_this_layer+extend_step] ;
		delete [] S[layer] ;
		S[layer] = pS ;
		pS = 0 ;

		double * pError ;

		// extension for Erorr[layer]
		pError = new double [neuron_this_layer+extend_step] ;
		delete [] Error[layer-1] ;
		Error[layer-1] = pError ;
		pError = 0 ;

		double * pWeight ;
		
		// extension for Weight[layer]
		for( i = 0 ; i < neuron[layer+1] + Remain_Empty[layer+1] ; i++ ){
			pWeight = new double [neuron_this_layer + 1 + extend_step] ;
			for ( j = 0 ; j < neuron[layer] ; j++ )
				pWeight[j] = Weight[layer][i][j] ;

			pWeight[j] = rand_weight(1.0) ;
			pWeight[j+1] = Weight[layer][i][j] ;	// bias weight

			delete [] Weight[layer][i] ;
			Weight[layer][i] = pWeight ;
			pWeight = 0 ;
		}

		double ** ppWeight ;
		// extension for Weight[layer-1]

		ppWeight = new double* [neuron_this_layer+extend_step] ;

		for( i = 0 ; i < neuron_this_layer + extend_step ; i++ ) 
			ppWeight[i] = new double  [ neuron[layer-1] + Remain_Empty[layer-1] + 1 ];

		/////// for all neuron include the new one ////////////////////
		for( i = 0 ; i < neuron_this_layer ; i++ ) {
		
			// copy the original weight and generate a new initial one
			for( j = 0 ; j <= neuron[layer-1] ; j++ )
				ppWeight[i][j] = Weight[layer-1][i][j] ;

		}

		for( j = 0 ; j < neuron[layer-1] + 1  ; j++ )
			ppWeight[neuron_this_layer][j] = rand_weight(1.0) ;

		// free 
		for( i = 0 ; i < neuron_this_layer ; i++ )
			delete [] Weight[layer-1][i] ;

		delete [] Weight[layer-1] ;

		Weight[layer-1] = ppWeight ;
		ppWeight = 0 ;

		// Mask of Weight
		int * pMask ;
		pMask = new int [neuron_this_layer + 1] ;
		for( i = 0 ; i < neuron_this_layer ; i++ ) 
			pMask[i] = Training_Mask[layer][i] ;

		pMask[neuron_this_layer] = 0 ;
		delete Training_Mask[layer] ;
		Training_Mask[layer] = pMask ;
		pMask = 0 ;

		neuron[layer]++ ;
		Remain_Empty[layer] = extend_step - 1 ;
	}

	return 1 ;
}*/


int AIR_BP::add_neuron(int n, int layer){

	int i, j;

	if( layer >= num_layer || layer <= 0 ) 
		return 0 ;

	// the parameter 1 means modify the mask
	if( add_neuron_mode == AIR ) 
		layer = AmbiguityTest(1) ;

	// there are many variables to extend its size
	// Hidden layer : X[layer]
	// Weight : Weight[layer-1], Weight[layer] 
	// Sumation node : S[layer]
	// Error propagation : Error[layer]
	
	// variables to modify its value
	// num of neuron : neuron[layer]
	// Remain_Empty : because it has to
	if( Remain_Empty[layer] == 0 ) {		// do the extension of memory
		int neuron_this_layer = neuron[layer] ;

		double * pX ;

		// extension for X[layer]
		pX = new double [neuron_this_layer + 1 + extend_step ] ;
		pX[neuron_this_layer+1] = 1.0;	// set bias to 1.0

		for( i = 0 ; i < neuron_this_layer ; i++ )
			pX[i] = X[layer][i] ;
		pX[i] =  1.0 ;
		pX[i+1] = 1.0 ;

		delete [] X[layer] ;
		X[layer] = pX ;
		
		double * pS ;

		// extension for S[layer]
		pS = new double [neuron_this_layer+extend_step] ;
		delete [] S[layer] ;
		S[layer] = pS ;
		pS = 0 ;

		double * pError ;

		// extension for Erorr[layer]
		pError = new double [neuron_this_layer+extend_step] ;
		delete [] Error[layer-1] ;
		Error[layer-1] = pError ;
		pError = 0 ;

		double * pWeight ;
		
		// extension for Weight[layer]
		for( i = 0 ; i < neuron[layer+1] + Remain_Empty[layer+1] ; i++ ){
			pWeight = new double [neuron_this_layer + 1 + extend_step] ;

			for ( j = 0 ; j < neuron[layer]+1 ; j++ )	// copy the original data
				pWeight[j] = Weight[layer][i][j] ;

//			for ( j = 0 ; j < neuron[layer] ; j++ )
//				pWeight[j] = Weight[layer][i][j] ;
//
//			pWeight[j] = rand_weight(1.0) ;			// from new neuron
//			pWeight[j+1] = Weight[layer][i][j] ;	// bias weight

			delete [] Weight[layer][i] ;
			Weight[layer][i] = pWeight ;
			pWeight = 0 ;
		}

		double ** ppWeight ;
		// extension for Weight[layer-1]

		ppWeight = new double* [neuron_this_layer+extend_step] ;

		for( i = 0 ; i < neuron_this_layer + extend_step ; i++ ) 
			ppWeight[i] = new double  [ neuron[layer-1] + Remain_Empty[layer-1] + 1 ];

		/////// for all neuron include the new one ////////////////////
		for( i = 0 ; i < neuron_this_layer ; i++ ) {
		
			// copy the original weight
			for( j = 0 ; j <= neuron[layer-1] ; j++ )
				ppWeight[i][j] = Weight[layer-1][i][j] ;

		}

//		for( j = 0 ; j < neuron[layer-1] + 1  ; j++ )
//			ppWeight[neuron_this_layer][j] = rand_weight(1.0) ;	// to new neuron

		// free 
		for( i = 0 ; i < neuron_this_layer ; i++ )
			delete [] Weight[layer-1][i] ;

		delete [] Weight[layer-1] ;

		Weight[layer-1] = ppWeight ;
		ppWeight = 0 ;

		// Mask of Weight
		int * pMask ;
		pMask = new int [neuron_this_layer + 1] ;
		for( i = 0 ; i < neuron_this_layer ; i++ ) 
			pMask[i] = Training_Mask[layer][i] ;

		pMask[neuron_this_layer] = 0 ;
		delete Training_Mask[layer] ;
		Training_Mask[layer] = pMask ;
		pMask = 0 ;

		Remain_Empty[layer] = extend_step ;
	}

	// do the extension of data
		X[layer][neuron[layer]+1] = 1.0 ; // threshold node shift

		// Weight modification is to be coded here	***************************************

		// for upper layer
		for( i = 0 ; i < neuron[layer+1] ; i++ ){
			Weight[layer][i][neuron[layer]+1] = Weight[layer][i][neuron[layer]] ; // shift the weight of threshold
			Weight[layer][i][neuron[layer]] = rand_weight(1.0) ;	// give a random weight to the new neuron
		}

		// for low layer

		if( add_neuron_mode == Random ) {
			for( j = 0 ; j < neuron[layer-1]+1 ; j++ )
				Weight[layer-1][neuron[layer]][j] = rand_weight(1.0) ;	// give a random weight
		}
		
		else if( add_neuron_mode == AIR ){

			for( i = 0  ; i < neuron[layer-1] + 1 ; i++ ){
				
				Weight[layer-1][neuron[layer]][i] = m_Weight_Buf[i] ;
			}
		}
/*
		else if( add_neuron_mode == AIR ){
			int count ;
			double sum  ;

			for( i = 0  ; i < neuron[layer-1] + 1 ; i++ ){
				
				count = 0 ;
				sum = 0.0 ;

				for( j = 0 ; j < neuron[layer] ; j++ ){		// average of unmasked neuron
					if( Training_Mask[layer][j] == 0 ) {
						sum += Weight[layer-1][j][i] ; 
						count++ ;
					}
				}
				Weight[layer-1][neuron[layer]][i] = sum / count ;
			}
		}
*/			

		// initially unmasked
		Training_Mask[layer][neuron[layer]] = 0 ;

		neuron[layer]++ ;
		Remain_Empty[layer]-- ;


	return 1 ;
}



double AIR_BP::Train() {
	int i, j, k, m, n ;
	double sum, E, temp ;
	
	// shuffle

	E = 0.0 ;

	for( i = 0 ; i < num_pat ; i++ ){
		j = rand() % num_pat ;

		k = index[i] ;
		index[i] = index[j];
		index[j] = k;
	}

	for( n = 0 ; n < num_pat ; n++ ){	// for all pattern
		i = index[n] ;

		// copy input to network
		for( j = 0 ; j < neuron[0] ; j++ )
			X[0][j] = Input[i][j] ;			// include bias, br careful

		// iteration to calculate hidden layer and output layer output

		// for all layers
		for( j = 1 ; j < num_layer + 1 ; j++ ){

			// for all neurons in layer j+1	( output )
			for( k = 0 ; k < neuron[j] ; k++ ){
				S[j][k] = 0.0 ;

				// for all neurons in layer j ( input ) 
				for( m = 0 ; m < neuron[j-1] + 1 ; m++ )		// include bias
					S[j][k] += Weight[j-1][k][m] * X[j-1][m] ; 
			

				Eval_AC(X[j][k], S[j][k], activation[j]) ;

				// hidden output, bipolar tanh
//				if( activation[j-1] == BITAN )
//					X[j][k] = alpha * tanh(beta * X[j][k]) ;

				// unipolar
//				else if( activation[j-1] == UNITAN )
//					X[j][k] = (alpha * tanh(beta* X[j][k]) + alpha) / 2 ;
			}
		}

		// now forward calculation is done. 


		// Error accumulation
		for( j = 0 ; j < neuron[num_layer] ; j++ )
			E += 0.5 * (Desire[i][j] - X[num_layer][j]) * (Desire[i][j] - X[num_layer][j]) ;


	
		// calculate output layer Error
		for( j = 0 ; j < neuron[num_layer] ; j++ ){
			temp = X[num_layer][j] ;
			
			if( activation[num_layer] == BITAN )
				Error[num_layer-1][j] = (Desire[i][j] - temp) * ( beta/alpha ) * ( alpha - temp ) * ( alpha + temp ) ;
			else if( activation[num_layer] == UNITAN )
				Error[num_layer-1][j] = (Desire[i][j] - temp) * 2 * ( beta / alpha ) * ( alpha - temp ) * temp ;
		}

		// BP algorithm
		for( j = num_layer - 1 ; j > 0 ; j-- ){
			for( k = 0 ; k < neuron[j] ; k++){
				sum = 0.0 ;

				for( m = 0 ; m < neuron[j+1] ; m++ )
					sum += Error[j][m] * Weight[j][m][k] ;

				temp = X[j][k] ;

				if( activation[j] == BITAN )
					Error[j-1][k] = sum * ( beta / alpha ) * ( alpha - temp ) * ( alpha + temp ) ;
				else if( activation[j] == UNITAN )
					Error[j-1][k] = sum * 2 * ( beta / alpha ) * ( alpha - temp ) * temp ;
			}
		}

		// update weight
		if( add_neuron_mode == AIR ){		// if mask is enabled
			for( j = 0 ; j < num_layer; j++ )
				for( k = 0 ; k < neuron[j+1] ; k++ ){
					if( Training_Mask[j+1][k] == 0 ) 
						for( m = 0 ; m < neuron[j]+1 ; m++ )
							Weight[j][k][m] += learn_rate * Error[j][k] * X[j][m];
				}
		}
		else{ // mask is disabled
			for( j = 0 ; j < num_layer; j++ )
				for( k = 0 ; k < neuron[j+1] ; k++ )
					for( m = 0 ; m < neuron[j]+1 ; m++ )
						Weight[j][k][m] += learn_rate * Error[j][k] * X[j][m];
		}
		

	}

	return E ;
}

int AIR_BP::ReDistribute(double scale){
	int i, j;
	for( i = 1 ; i <= num_layer ; i++ )
		for( j = 0 ; j < neuron[i] ; i++ )
			Training_Mask[i][j] = 0 ;		// reset all mask 

	return SuperviseSystem::ReDistribute(scale) ;
}

int AIR_BP::AmbiguityTest(int mode) {

	int i, j, k, m, bitpat, desire;

	AmbiguityNode *node, *ptr ;

	std::deque<AmbiguityNode *> q ;	// a queue
	std::deque<AmbiguityNode *>::iterator iter, cmp_iter ;


	// construct hamming tree layer one, dump all Input into first layer
	for( i = 0 ; i < num_pat ; i++ ){	// for all patterns

		// copy input to network
		for( j = 0 ; j < neuron[0] ; j++ )
			X[0][j] = Input[i][j] ;			// include bias, be careful

		for( k = 0 ; k < neuron[1] ; k++ ){
			S[1][k] = 0.0 ;

			for( m = 0 ; m < neuron[0] + 1 ; m++ )		// include bias
				S[1][k] += Weight[0][k][m] * X[0][m] ; 
			
			Eval_AC(X[1][k], S[1][k], activation[1]) ;
		}
		
		bitpat = GetPattern(1) ;				// retrive the corner of hypercube 
		desire = GetDesirePattern(i);			// desired output for input[i] 

		for( iter = q.begin() ; iter != q.end() ; iter++ )
		{
			if( (*iter)->bitpat == bitpat ) {
				
				(*iter)->_list_pattern.push_back(i) ;		// add new pattern to this class

				if( (*iter)->desire != desire ) {
					(*iter)->state = Conflict ;				// conflict node if desire not the same
					(*iter)->_list_pattern.push_back(i) ;
					break;
				}

				// pout weighting, increment sum_leaf ********************************************
				//////////////////////////////////////////////////////////////////////////////////
				double ratio = 1 / ( (*iter)->sum_leaf + 1 ) ;
				for( j = 0 ; j < neuron[1] ; j++ )
					(*iter)->pout[j] = (*iter)->pout[j] * (1-ratio) + X[1][j] ;

				(*iter)->sum_leaf ++ ;

			}
		}

		// if this kind of I/O relation is absent in layer 1
		if( iter == q.end() ){
			node = new AmbiguityNode ;

			// although we have binary pattern , still store the real value
			node->pout = new double [neuron[1]] ;
			for( j = 0 ; j < neuron[1] ; j++ )
				node->pout[j] = X[1][j] ;

			node->bitpat = bitpat;
			node->desire = desire;
			node->layer = 1 ;			// layer of this node
			node->sum_leaf = 1;			// i am a leaf node

			node->state = Pure ;
			node->_list_pattern.push_back(i) ;	// memorize the pattern
			q.push_back(node) ;
		}
	}
	
	// check for layer 1 ambiguity
	int layer_conflict = 0 ;

	for( iter = q.begin() ; iter != q.end() ; iter++ ) {

		if( (*iter)->state == Conflict )	// mask unrelated neurons
			layer_conflict = 1 ;
	}

	if ( layer_conflict == 0 ){	// normal case, iteratively solution

		cmp_iter = q.end() ;

		while( !q.empty() ){

			if( cmp_iter == q.begin() ){		// begining of new layer

				for( iter = q.begin() ; iter != q.end() ; iter++ )
					if( (*iter)->state == Conflict ) {
						layer_conflict = (*iter)->layer ; 
						goto L100 ;
					}

				cmp_iter = q.end() ;	// spare the search time if Dimension is very large
			}

			ptr = q.front();

			// end
			if( ptr->layer == num_layer ){
				layer_conflict = num_layer+1 ;	// no conflict
				goto L110 ;
			}

			m = ptr->layer + 1;


			// restore pattern from node into X[m-1][]
			for( i = 0 ; i < neuron[m-1] ; i++ )
				X[m-1][i] = ptr->pout[i] ;


			// simulate layer m with input of this node
			for ( i = 0 ; i < neuron[m] ; i++ ){
				S[m][i] = 0.0 ;

				for( j = 0 ; j < neuron[m-1] + 1 ; j++ )
					S[m][i] += Weight[m-1][i][j] * X[m-1][j] ;

				Eval_AC(X[m][i], S[m][i], activation[m]) ;
			}

			bitpat = GetPattern(m) ;

			// for all created neuron in layer m in queue
			for( iter = cmp_iter ; iter != q.end() ; iter++ )
				if( (*iter)->bitpat == bitpat ){

					if( (*iter)->desire == ptr->desire ){ // this parent has same desire with child
						double ratio ;

						(*iter)->_list_child.push_back( ptr ) ;	// add child to list, front is same desire

						ratio = ptr->sum_leaf / ( (*iter)->sum_leaf + ptr->sum_leaf ) ;

						for( i = 0 ; i < neuron[m] ; i++ )
							(*iter)->pout[i] = (*iter)->pout[i] * (1-ratio) + ptr->pout[i] * ratio ;
						
						(*iter)->sum_leaf += ptr->sum_leaf ;	// sumation leaf
					}

					else { // this parent has different desire with child

						(*iter)->state = Conflict ;
						(*iter)->_list_child.push_back( ptr ) ;	// back is different desire
						(*iter)->sum_leaf += ptr->sum_leaf ;
						layer_conflict = m ;
					}
					
					break;				
				}

			// this output pattern absent in layer m, create a new node and push_back to queue
			if( iter == q.end() ){
				node = new AmbiguityNode ;

				// although we have binary pattern , still store the real value
				node->pout = new double [neuron[m]] ;
				for( j = 0 ; j < neuron[m] ; j++ )
					node->pout[j] = X[m][j] ;

				node->bitpat = bitpat ;
				node->desire = ptr->desire ;
				node->layer = m ;
				node->state = ptr->state ;
				node->_list_child.push_back(ptr) ;
				node->sum_leaf = ptr->sum_leaf ;
				q.push_back(node) ;
			}
			
			q.pop_front() ;
		}
	}	

L100 :

	// mask the Weight training 
	if( mode == 1 )  { // perform masking operation and Weight tuning
		for( iter = q.begin() ; iter != q.end() ; iter++ ) {

			if( (*iter)->state == Conflict ){	// mask unrelated neurons
				
				int flag = 1 << (neuron[layer_conflict]-1) ; 
				int neighbor_bitpat ;
				for( i = 0 ; i < neuron[layer_conflict] ; i++ ){

					neighbor_bitpat = (*iter)->bitpat ^ flag ;

					for( cmp_iter = q.begin() ; cmp_iter != q.end() ; cmp_iter++ ){
						if( (*cmp_iter)->bitpat == neighbor_bitpat ) 
							break ;
					}

					if( cmp_iter == q.end() ) // this neighbor is not found, so mask the corresponding neuron
						Training_Mask[layer_conflict][i] = 1;

					flag >>= 1	;	// next neuron
				}
				
				break ;
			}
		}

		if( m_Weight_Buf )
			delete [] m_Weight_Buf ;
		
		m_Weight_Buf = new double [neuron[layer_conflict-1]+1] ;
		for( i = 0 ; i < neuron[layer_conflict-1] + 1 ; i++ )
			m_Weight_Buf[i] = 0 ;

		// weight tuning buffer

		// excepy layer one
		if( layer_conflict != 1 ){
			for( i = 0 ; i < (*iter)->_list_child.size() ; i++ ){
				ptr = (*iter)->_list_child[i] ;
				for( j = 0 ; j < neuron[layer_conflict-1] ; j++ )
					m_Weight_Buf[j] += ptr->pout[j] ;
			}

			for( i = 0 ; i < neuron[layer_conflict-1] ; i++ ){
				m_Weight_Buf[i] /= (*iter)->_list_child.size() ;	// normalize
				m_Weight_Buf[neuron[layer_conflict-1]] -= (m_Weight_Buf[i]*m_Weight_Buf[i]) ;
			}
		}
		else{
			for( i = 0 ; i < (*iter)->_list_pattern.size() ; i++ ){
				for( j = 0 ; j < neuron[0] ; j++ )
					m_Weight_Buf[j] += Input[i][j] ;				
			}

			for( i = 0 ; i < neuron[0] ; i++ ){
				m_Weight_Buf[i] /= (*iter)->_list_pattern.size() ;
				m_Weight_Buf[neuron[0]] -= (m_Weight_Buf[i]*m_Weight_Buf[i]) ;
			}
		}

	}

L110 :
	// destroy all 

	std::vector<AmbiguityNode *>::iterator vec_iter ;

	while( !q.empty() ) {

		ptr = q.front() ;
		q.pop_front() ;

		// iteratively deletion
		if( ptr->pout ) 
			delete [] ptr->pout ;
		ptr->pout = 0 ;

		if( ptr->layer > 1 ) {
			for( vec_iter = ptr->_list_child.begin() ; vec_iter != ptr->_list_child.end() ; vec_iter++ ){
				q.push_back(*vec_iter) ;
				*vec_iter = 0 ;
			}

			ptr->_list_child.clear() ;
		}
		else
			ptr->_list_pattern.clear() ;

		delete ptr ;
		ptr = 0 ;
		
	}

	return layer_conflict; 
}
