#ifndef __AIR_BP__
#define __AIR_BP__

#include "SuperviseSystem.h"

struct BPRect {
	double left, top, right, bottom ;
} ;


class AIR_BP : public SuperviseSystem{

public :
	AIR_BP() ;
	virtual ~AIR_BP() ;

//	inline void EnableWeightMask() ;
//	inline void DisableWeightMask() ;
//	inline int WeightMasked() ;

	enum AddNeuronMode { Random, AIR } ;

	inline void SetAddNeuronMode( enum AddNeuronMode mode ) ;
	inline enum AddNeuronMode GetAddNeuronMode() ;
	////////////////
	// pure virtual
	////////////////
	// return error
	virtual double Train() ;
	// load pattern and info of network architecture
	virtual int Load(const char* filename) ;

	//interface
	// add n neurons to layer ( layer 0 is input ) ;
	int add_neuron(int n, int layer) ;
	virtual int ReDistribute(double scale) ;


	// mode 0 : non-masking operation performed
	// mode 1 : masking operation performed
	// return value is the number of conflict layer
	int AmbiguityTest(int mode) ;

protected :

	// destroy all data
	virtual int DestroyBP() ;

	// variables
	// it can determine whether the weight of that neuron is trainable
	// value 1 implies the neuron is masked
	int ** Training_Mask ;	
	// the remaining "empty" neuron of specific layer
	int * Remain_Empty ;

	double * m_Weight_Buf ;

	// 1 is masking while training
	// 0 is non-masking while training
//	int flag_weight_mask ;

	enum AddNeuronMode add_neuron_mode ;

	// 
private : 
	int extend_step ;

	// 0 disable, 1 enable


};

//inline void AIR_BP::EnableWeightMask() { flag_weight_mask = 1 ; }
//inline void AIR_BP::DisableWeightMask(){ flag_weight_mask = 0 ; }
//inline int AIR_BP::WeightMasked() { return flag_weight_mask ; }
inline void AIR_BP::SetAddNeuronMode( enum AIR_BP::AddNeuronMode mode ) { 
	add_neuron_mode = mode ;
}
inline enum AIR_BP::AddNeuronMode AIR_BP::GetAddNeuronMode() {
	return add_neuron_mode ;
}

#endif